package winterwell.utils;

/**
 * Exception indicating that although your request was reasonable,
 * <i>something</i> has gone wrong, often with a 3rd party system.
 * 
 * @author daniel
 */
public class FailureException extends RuntimeException {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String source;

	public FailureException() {
		super();
	}

	public FailureException(Exception e) {
		super(e);
	}

	public FailureException(String msg) {
		super(msg + " @" + Utils.getCaller());
	}

	public FailureException(String msg, Exception cause) {
		super(msg + " @" + Utils.getCaller(), cause);
	}

	public FailureException(String source, String msg) {
		super(source + ": " + msg + " @" + Utils.getCaller());
		this.source = source;
	}

	public String getSource() {
		return source;
	}

}
