/**
 *
 */
package winterwell.utils.containers;

import java.util.AbstractQueue;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * A queue that leaks tail elements when it reaches the specified capacity.
 * Status: Sketch. Not convinced.
 * 
 * @author joe
 * 
 */
public class LeakyQueue<T> extends AbstractQueue<T> {

	LinkedList<T> backing;
	int maxSize;

	public LeakyQueue(int maxSize) {
		this(maxSize, new ArrayList());
	}

	public LeakyQueue(int maxSize, Collection<? extends T> init) {
		this.maxSize = maxSize;
		this.backing = new LinkedList<T>(init);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.AbstractCollection#iterator()
	 */
	@Override
	public Iterator<T> iterator() {
		return backing.iterator();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Queue#offer(java.lang.Object)
	 */
	@Override
	public boolean offer(T e) {
		if (backing.size() == maxSize) {
			backing.pollLast();
			backing.addFirst(e);
		}
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Queue#peek()
	 */
	@Override
	public T peek() {
		return backing.peek();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Queue#poll()
	 */
	@Override
	public T poll() {
		return backing.poll();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.AbstractCollection#size()
	 */
	@Override
	public int size() {
		return backing.size();
	}

}
