package winterwell.utils.time;

import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * 
 * @author daniel
 * @testedby TimeOfTest
 */
public class TimeOf {

	GregorianCalendar time;

	TUnit unit;

	public TimeOf(TUnit unit, Time example) {
		this.unit = unit;
		time = example.getCalendar();
		// zero
		zero(time);
	}

	public void advance(GregorianCalendar cal) {
		GregorianCalendar cal2 = (GregorianCalendar) cal.clone();
		zero(cal2);
		long t2 = cal2.getTimeInMillis();
		long t = time.getTimeInMillis();
		long dt = t - t2;
		if (dt == 0)
			return;
		assert dt < Integer.MAX_VALUE : cal2;
		if (dt > 0) {
			cal.add(Calendar.MILLISECOND, (int) dt);
		} else {
			// bugger - we need to roll the day/week forward
			cal.roll(unit.getCalendarField(), true);
			cal.add(Calendar.MILLISECOND, (int) dt);
		}
	}

	public boolean isAfter(GregorianCalendar cal) {
		// don't edit!
		cal = (GregorianCalendar) cal.clone();
		zero(cal);
		System.out.println(new Time(cal));
		System.out.println(new Time(time));
		return time.after(cal);
	}

	public boolean isBefore(GregorianCalendar cal) {
		// don't edit!
		cal = (GregorianCalendar) cal.clone();
		zero(cal);
		return time.before(cal);
	}

	void zero(GregorianCalendar cal) {
		for (TUnit larger : TUnit.values()) {
			if (larger.getMillisecs() < unit.getMillisecs()) {
				continue;
			}
			cal.set(larger.getCalendarField(), 0);
		}
	}

}
